<?php

namespace App\Policies;

use App\Models\Designer;
use App\Models\User;
use Illuminate\Auth\Access\HandlesAuthorization;

class DesignerPolicy
{
    use HandlesAuthorization;

    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasPermissionTo('view designers');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, Designer $designer): bool
    {
        return $user->hasPermissionTo('view designers');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create designers');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, Designer $designer): bool
    {
        return $user->hasPermissionTo('edit designers');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, Designer $designer): bool
    {
        return $user->hasPermissionTo('delete designers');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, Designer $designer): bool
    {
        return $user->hasPermissionTo('restore designers');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, Designer $designer): bool
    {
        return $user->hasPermissionTo('force delete designers');
    }
}